/*

 DC Radio filter board serial interface. 74HC595D latch driver
 
 Juha Niinikoski OH2NLT 07.10.2004


*/


// send 8-bit data to filter board shift register / latch
// 74HC595 clock and latch signals are inverted
// 

void send_hc595(unsigned char bits)
	{
	char x;
	for(x=0; x<8; x++)		// do 8-bits, MSB first
		{
		if(bits & 0x80)
			HC595_DATA = 1;	// set data
		else
			HC595_DATA = 0;

		HC595_CLOCK = 1;	// generate clock pulse
		bits = bits << 1;	// shift data & delay
		asm("nop");
		HC595_CLOCK = 0;	// falling edge active, inverted at filter board
		}

	HC595_LATCH = 1;		// generate latch pulse
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	HC595_LATCH = 0;		// falling edge active, inverted at filter board
	}

